<!-- 搜索表单 -->
<template>
  <a-space>
    <a-button
      type="primary"
      class="ele-btn-icon"
      v-permission="'oa:assets:save'"
      @click="add"
    >
      <template #icon>
        <PlusOutlined />
      </template>
      <span>新建</span>
    </a-button>
    <a-button
      danger
      type="primary"
      class="ele-btn-icon"
      :v-role="`dev`"
      @click="removeBatch"
      v-if="props.selection.length > 0"
    >
      <template #icon>
        <DeleteOutlined />
      </template>
      <span>批量删除</span>
    </a-button>
    <a-input-search
      allow-clear
      v-model:value="searchText"
      placeholder="请输入搜索关键词"
      @search="search"
      @pressEnter="search"
    >
      <template #addonBefore>
        <a-select v-model:value="type" style="width: 120px; margin: -5px -12px">
          <a-select-option value="name">服务器名称</a-select-option>
          <a-select-option value="code">服务器IP</a-select-option>
          <a-select-option value="userId">用户ID</a-select-option>
        </a-select>
      </template>
    </a-input-search>
  </a-space>
</template>

<script lang="ts" setup>
  import { PlusOutlined, DeleteOutlined } from '@ant-design/icons-vue';
  import useSearch from '@/utils/use-search';
  import type { AssetsParam } from '@/api/oa/assets/model';
  // import SelectUser from '@/components/SelectUser/index.vue';
  import { ref, watch } from 'vue';
  import { assignObject } from 'ele-admin-pro';

  const emit = defineEmits<{
    (e: 'search', where?: AssetsParam): void;
    (e: 'add'): void;
    (e: 'remove'): void;
  }>();

  const props = defineProps<{
    // 勾选的项目
    selection?: [];
  }>();

  // 表单数据
  const { where } = useSearch<AssetsParam>({
    name: '',
    code: '',
    isExpire: '',
    userId: undefined
  });

  // 下来选项
  const type = ref('name');
  // 搜索内容
  const searchText = ref('');

  /* 搜索 */
  const search = () => {
    assignObject(where, {});
    if (type.value == 'name') {
      where.name = searchText.value;
    }
    if (type.value == 'code') {
      where.code = searchText.value;
    }
    if (type.value == 'userId') {
      const number = Number(searchText.value);
      if (number > 0) {
        where.userId = Number(searchText.value);
      }
    }
    emit('search', where);
  };

  // const onSelect = (userId) => {
  //   console.log(userId);
  //   where.userId = userId;
  //   console.log(where);
  //   search();
  // };
  // const onClear = () => {
  //   where.userId = undefined;
  //   search();
  // };

  // 新增
  const add = () => {
    emit('add');
  };

  // 批量删除
  const removeBatch = () => {
    emit('remove');
  };

  /*  重置 */
  // const reset = () => {
  //   resetFields();
  //   search();
  // };

  // 监听字典id变化
  watch(
    () => props.selection,
    () => {}
  );
</script>
